Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members

# TAO_Interpreter Class Reference

TAO_Interpreter is the superclass for all interpreters. Its build tree method invokes the yacc parser to parse a constraint or preference string. More...

`#include <Interpreter.h>`

Inheritance diagram for TAO_Interpreter:

[legend]
Collaboration diagram for TAO_Interpreter:

[legend]
List of all members.

## Protected Methods
| TAO_Interpreter (void)
| Constructor. More...
| ~TAO_Interpreter (void)
| Destructor. More...
int | build_tree (const char *preferences)
| Using the Yacc generated parser, construct an expression tree representing <constraints> from the tokens returned by it. More...
## Static Protected Methods
int | is_empty_string (const char *str)
## Protected Attributes
TAO_Constraint * | root_
| The root of the expression tree, not equal to null if build_tree successfully builds a tree from the constraints. More...
## Static Private Attributes
TAO_SYNCH_MUTEX | parserMutex__
| This mutex protects the <build_tree> method from reentrance. More...

## Detailed Description

TAO_Interpreter is the superclass for all interpreters. Its build tree method invokes the yacc parser to parse a constraint or preference string.

## Constructor & Destructor Documentation

TAO_Interpreter::TAO_Interpreter | ( | void |  | ) | `[protected]`

| Constructor.

TAO_Interpreter::~TAO_Interpreter | ( | void |  | ) | `[protected]`

| Destructor.

## Member Function Documentation

int TAO_Interpreter::build_tree | ( | const char * | constraints | ) | `[protected]`

| Using the Yacc generated parser, construct an expression tree representing <constraints> from the tokens returned by it.

int TAO_Interpreter::is_empty_string | ( | const char * | str | ) | `[static, protected]`

## Member Data Documentation

TAO_SYNCH_MUTEX TAO_Interpreter::parserMutex__`[static, private]`

| This mutex protects the <build_tree> method from reentrance.

TAO_Constraint* TAO_Interpreter::root_`[protected]`

| The root of the expression tree, not equal to null if build_tree successfully builds a tree from the constraints.

The documentation for this class was generated from the following files:

- Interpreter.h
- Interpreter.cpp